#include <algorithm>
#include <iostream>
#include <chrono>
#include <vector>

using namespace std;
using namespace std::chrono;

using MatrixRow = vector<double>;
using MatrixColumn = vector<double>;
using Matrix = vector<vector<double>>;

int main()	{
	// Initialize the matrix by zero values.
	constexpr int M = 8000, N = 8000;
	Matrix m(M, MatrixRow(N, 0.0));

	// Fill the matrix such that total sum is one.
	for (int i = 0; i < M; ++i)	{
		for (int j = 0; j < N; ++j)
			m[i][j] = 1.0/(M*N);
	}

	high_resolution_clock::time_point start = high_resolution_clock::now();

	// Sum all the entries in the matrix.
	MatrixColumn sumOfRows(M, 0.0);
	for (int i = 0; i < M; ++i)	{
		for (int j = 0; j < N; ++j)
			sumOfRows[i] += m[i][j];
	}

	double totalSum = 0.0;
	for (int i = 0; i < M; ++i)
		totalSum += sumOfRows[i];

	cout<<"Sum of matrix elements: "<<totalSum<<endl;
	double runtime = duration_cast<duration<double>>(high_resolution_clock::now()-start).count();
	cout<<"Total runtime: "<<runtime<<" s"<<endl;

	return 0;
}

